<?php
/***********************************************************************
 *                                                                      **
**                          Gubed - PHP Debugger                        **
**                      (c) 2002 - 2004 Linus McCabe                    **
**                                                                      **
** This program is free software; you can redistribute it and/or modify **
** it under the terms of the GNU General Public License as published by **
** the Free Software Foundation; either version 2 of the License, or    **
** (at your option) any later version.                                  **
**                                                                      **
** This program is distributed in the hope that it will be useful,      **
** but WITHOUT ANY WARRANTY; without even the implied warranty of       **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        **
** GNU General Public License for more details.                         **
**                                                                      **
** You should have received a copy of the GNU General Public License    **
** along with this program; if not, write to the Free Software          **
** Foundation, Inc.                                                     **
** 59 Temple Place, Suite 330                                           **
** Boston, MA  02111-1307  USA                                          **
**                                                                      **
************************************************************************/

   if(isset($_REQUEST['gbdNoDebug']))
      return;

   require_once("GubedFunctions.php");

   if(!isset($GLOBALS['gbd']['gbdScript'])) {   
      $GLOBALS['gbd']['gbdScript'] = basename($_SERVER['PHP_SELF']);
      if($GLOBALS['gbd']['gbdScript'] == "")
        $GLOBALS['gbd']['gbdScript'] = $_SERVER['argv'][0];
    }

   if(!isset($GLOBALS['gbd']['gbdPath']))
      $GLOBALS['gbd']['gbdPath'] = "";

   if(!isset($GLOBALS['gbd']['gbdSession']))
      $GLOBALS['gbd']['gbdSession'] = 0;

   $gbdThisScript = gbdFindFile($GLOBALS['gbd']['gbdScript']);

   //Scripts that we never want to debug - put them in gbdNoDebug.txt
   if(gbdCheckNoDebug($gbdThisScript)) {
      if($GLOBALS['gbd']['gbdScriptRequire'] == 'require')
         require($GLOBALS['gbd']['gbdScript']);
      else
         include($GLOBALS['gbd']['gbdScript']);
      return;
   }

   // We need to add all paths to the path, because inclusion of files ./ is messed up otherwise :(
   // This still doesent allow for paths relative to paths
   if(!in_array(dirname($gbdThisScript), split(PATH_SEPARATOR, ini_get("include_path"))))
      ini_set("include_path", ini_get("include_path") . PATH_SEPARATOR . dirname($gbdThisScript));

   if(!isset($GLOBALS['gbd']['gbdTimer']))
      $GLOBALS['gbd']['gbdTimer'] = gbdGetmicrotime();
   $gbdTimer = gbdGetmicrotime();

   $gbdPhpCode = gbdReadScript($gbdThisScript);
   //$gbdThisScript = str_replace('\\', '/', str_replace(':', '', $gbdThisScript));
   $gbdPhpOrigCode = $gbdPhpCode;
   $gbdPhpCode = gbdParseCode($gbdThisScript, $gbdPhpCode, 0, $t, $GLOBALS['gbd']['gbdCount'] == 0 && $GLOBALS['gbd']['gbdSession'] == 0);

   $GLOBALS['gbd']['gbdCount'] ++;
   $GLOBALS['gbd']['gbdPhpOrigCode'][$gbdThisScript] = $gbdPhpOrigCode;
   $GLOBALS['gbd']['gbdPhpCode'][$gbdThisScript] = $gbdPhpCode;
   unset($gbdPhpOrigCode);
   unset($gbdPhpCode);

   $gbdTimer = gbdGetmicrotime() - $gbdTimer;

   //ob_implicit_flush();

   gbdInitialize($gbdThisScript, $gbdTimer * 1000);
   $GLOBALS['gbd']['inclusion'][$GLOBALS['gbd']['gbdCount']] = $gbdThisScript;
   $GLOBALS['gbd']['unparsed'][$gbdThisScript] = true;
   
   ob_start();
   eval(' gbdSourceParsed("'.addslashes($gbdThisScript).'"); ?>'.$GLOBALS['gbd']['gbdPhpCode'][$gbdThisScript]);

   // If the script didnt parse, require it instead
   if(isset($GLOBALS['gbd']['unparsed'][$GLOBALS['gbd']['inclusion'][$GLOBALS['gbd']['gbdCount']]])) {
      ob_end_flush();
      require($gbdThisScript);
   }
   else
      ob_end_flush();
   
   gbdQuit($gbdThisScript);

   $GLOBALS['gbd']['gbdCount']--;
//    echo "<br>*** {$GLOBALS['gbd']['gbdCount']} $gbdThisScript ***<br />";
   
   if(!$GLOBALS['gbd']['gbdCount']) {
      $GLOBALS['gbd']['completetime'] = (gbdGetmicrotime() - $GLOBALS['gbd']['gbdTimer']) * 1000;
      if(!headers_sent()) {
         Header(sprintf('X-Gubed-Totaltime: %.2f ms', $GLOBALS['gbd']['completetime']));
         Header(sprintf('X-Gubed-EstimatedScripttime: %.2f ms', $GLOBALS['gbd']['completetime'] - $GLOBALS['gbd']['gubedtime'] * 1000));
         Header(sprintf('X-Gubed-Gubedtime: %.2f ms', $GLOBALS['gbd']['gubedtime'] * 1000));
         Header(sprintf('X-Gubed-Parsetime: %.2f ms', $GLOBALS['gbd']['parsetime'] * 1000));
      }

      gbdSendCommand('status', Array('message' => 'Completed in %1% ms', 'args' => 1, 'arg1' => sprintf('%.2f', $GLOBALS['gbd']['completetime'])));
      gbdFinalize();
      if(!$GLOBALS['gbd']['gbdSession'])
        die();
      restore_error_handler();
   }

?>
