<?php
/***********************************************************************
 *                                                                      **
**                          Gubed - PHP Debugger                        **
**                     (c) 2002 - 2004 Linus McCabe                     **
**                                                                      **
** This program is free software; you can redistribute it and/or modify **
** it under the terms of the GNU General Public License as published by **
** the Free Software Foundation; either version 2 of the License, or    **
** (at your option) any later version.                                  **
**                                                                      **
** This program is distributed in the hope that it will be useful,      **
** but WITHOUT ANY WARRANTY; without even the implied warranty of       **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        **
** GNU General Public License for more details.                         **
**                                                                      **
** You should have received a copy of the GNU General Public License    **
** along with this program; if not, write to the Free Software          **
** Foundation, Inc.                                                     **
** 59 Temple Place, Suite 330                                           **
** Boston, MA  02111-1307  USA                                          **
**                                                                      **
*************************************************************************/

   function gbdParseCode($gbdThisScript, $gbdPhpCode, $debug, &$returninfo, $gbdRedefineFuncs) {
      $gbdTempTimer = gbdGetmicrotime();

      if($GLOBALS['gbd']['cachedir'] != '' && file_exists($GLOBALS['gbd']['cachedir'] . md5($gbdThisScript)) && filemtime($GLOBALS['gbd']['cachedir'] . md5($gbdThisScript)) > filemtime($gbdThisScript) && !$debug && filemtime($GLOBALS['gbd']['cachedir'] . md5($gbdThisScript)) > filemtime(__FILE__)  && $gbdThisScript != '~') {
         $gbdThisScript =$GLOBALS['gbd']['cachedir'] . md5($gbdThisScript);
         Header("X-Gubed-UsedCache: {$gbdThisScript}", false);
         return gbdReadScript($gbdThisScript);
      }

      // Take care of <?xml in html files
      $gbdPhpCode = preg_replace("/^(<\\?xml .* ?>)/","<?php echo '\\1'; ?>",  $gbdPhpCode);
      $gbdPhpCode = gbdAddGubed($gbdPhpCode, $gbdRedefineFuncs);

      if($debug)
         $returninfo['gubedadded'] = $gbdPhpCode;

      $gbdPhpCode = preg_replace(
                  Array(
                     "/<gbdEndGubed>/",
                     "/<gbdGubed>([\\s@]*)([^'\[\"();?\\s]*)/",
                     "/<gbdGubed2>/",
                     "/\/\* STOP \*\//",
                     "/\_\_FILE\_\_/",                                  // Replace __FILE__ with real filename
                     "/\_\_F1LE\_\_/",                                  // Replace __F1LE__ with __FILE__, lame way of doing it :)
                     ),
                  Array(
                     ";",
                     $debug ? "if(gubed('\\2')) \\1\\2"   : "if(eval(gbdGubed('$gbdThisScript',__LINE__, gbdGet_defined_vars(get_defined_vars(), (isset(\$this) ? \$this : NULL)), '\\2'))) \\1\\2",
                     $debug ? "gubed() ? false : " : "!eval(gbdGubed('$gbdThisScript',__LINE__, gbdGet_defined_vars(get_defined_vars(), (isset(\$this) ? \$this : NULL)), '')) ? false : ",
                     $debug ? "breakpoint();" : "gbdHandleBreakPoint('$gbdThisScript',__LINE__, gbdGet_defined_vars(get_defined_vars(), (isset(\$this) ? \$this : NULL)));",
                     "'".realpath($gbdThisScript)."'",
                     '__FILE__'
                     ),
                  $gbdPhpCode);

      $GLOBALS['gbd']['parsetime'] += gbdGetmicrotime() - $gbdTempTimer;
      $GLOBALS['gbd']['gubedtime'] += gbdGetmicrotime() - $gbdTempTimer;
      return $gbdPhpCode;
   }

   function gbdAddGubed($strPhpCode, $gbdRedefineFuncs) {

      $strPattern = "/  ( ; | \/\* | \/\/ | \# |  \?\> | \} | \{ ) [\s\f\n\r]* /mx";
      
      $intPos1 = gbdPregPos("/\<\?(php)?\s*/", $strPhpCode, 0, true);
      $strNewPhpCode = substr($strPhpCode, 0, $intPos1);
      $strPhpCode = substr($strPhpCode, $intPos1);
      $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
      $blockcount = 0;
      
      while($intPos1 >= 0) {
         
         //echo '<br><hr>: {' . gbdGetFirstToken(substr($strPhpCode, 0, $intPos1 )). '} : (' . substr($strPhpCode, 0, $intPos1 ) . ')<br>';
         $token = gbdGetFirstToken(substr($strPhpCode, 0, $intPos1 ));
         switch($token) {
         
            case 'include':
               $gbdIncludeRequire = 'include';
               $gbdIncludeRequireOnce = '';
               
            case 'include_once':
               if(!isset($gbdIncludeRequire)) $gbdIncludeRequire  = 'include';
               if(!isset($gbdIncludeRequireOnce)) $gbdIncludeRequireOnce  = 'Once';
            
            case 'require_once':
               if(!isset($gbdIncludeRequire)) $gbdIncludeRequire  = 'require';
               if(!isset($gbdIncludeRequireOnce)) $gbdIncludeRequireOnce  = 'Once';
               
            case 'require':
               if(!isset($gbdIncludeRequire)) $gbdIncludeRequire  = 'require';
               if(!isset($gbdIncludeRequireOnce)) $gbdIncludeRequireOnce  = '';
               
               $intPos1 = gbdPregPos("/ [\s\(] /x", $strPhpCode, 0, false);
               $strPhpCode = substr($strPhpCode, $intPos1);

               $intPos1 = gbdFindEOS(&$strPhpCode, 0, false);
               $strNewPhpCode .= ' <gbdGubed> { $GLOBALS[\'gbd\'][\'gbdNoHalt\'] = true; $gbdInclude = ' . substr($strPhpCode, 0, $intPos1)
                              ." ;\$gbdIncludeRequire = '{$gbdIncludeRequire}';  \$GLOBALS['gbd']['gbdNoHalt'] = false; include('GubedInclude{$gbdIncludeRequireOnce}.php');}";
               //$strNewPhpCode .= ' <gbdGubed> { $gbdInclude = ' . substr($strPhpCode, 0, $intPos1)
               //               ." ;\$gbdIncludeRequire = '{$gbdIncludeRequire}'; include('GubedInclude{$gbdIncludeRequireOnce}.php');}";
               $strPhpCode = substr($strPhpCode, $intPos1);
                              
               //$strPhpCode = substr($strPhpCode, $intPos1);
               $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
               
               unset($gbdIncludeRequireOnce);
               unset($gbdIncludeRequire);
               break;

            case '=':
               $intPos1 = gbdFindEOS(&$strPhpCode);
               $strNewPhpCode .= ' <gbdGubed>' . ' echo ' . substr($strPhpCode, 1, $intPos1 - 1) . ' <gbdEndGubed>';
               
               $strPhpCode = substr($strPhpCode, $intPos1);
               $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
               break;
               
            case '/*':
               $intPos1 = gbdPregPos("/ \*\/ [\s\n\f\r]* /x", $strPhpCode, 0, true);
               $strNewPhpCode .= substr($strPhpCode, 0, $intPos1);
               $strPhpCode = substr($strPhpCode, $intPos1);
               $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
               break;
               
               
            case '//':
            case '#':
               $intPos1 = gbdPregPos("/ [\n\r\f] [\s\n\f\r]* /x", $strPhpCode, 0, true);
               $strNewPhpCode .= substr($strPhpCode, 0, $intPos1);
               $strPhpCode = substr($strPhpCode, $intPos1);
               $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
               break;

            case '':
                echo strlen($strPhpCode) . "<hr> " .htmlentities($strNewPhpCode);
                die();
                $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
                $strNewPhpCode .= substr($strPhpCode, 0, $intPos1);
                $strPhpCode = substr($strPhpCode, $intPos1);
                $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
                
                break;
            
            case 'global':
            case 'var':
            case 'static':
               $intPos1 = gbdFindEOS(&$strPhpCode);
               $strNewPhpCode .= substr($strPhpCode, 0, $intPos1 );
               $strPhpCode = substr($strPhpCode, $intPos1);

               $intPos1 = gbdPregPos("/ ^\s* ; [\s\n\r\f]* /x", $strPhpCode, 0, true);
               $strNewPhpCode .= substr($strPhpCode, 0, $intPos1 );
               $strPhpCode = substr($strPhpCode, $intPos1);
               
               
               $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
               break;

            case 'if':
            case 'while':
            case 'switch':
            case 'foreach':
               $intPos1 = gbdFindEOS(&$strPhpCode, 0, 1);
               $strNewPhpCode .= '<gbdGubed> ' . substr($strPhpCode, 0, $intPos1);
               $strPhpCode = substr($strPhpCode, $intPos1);
               
               if(!preg_match("/^\s*{/", $strPhpCode)) {
                  $strNewPhpCode .= ' { ';
                  $blockcount ++;  
               }
               
               $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
               break;
            
            case 'for':
               
               $intPos1 = gbdFindEOS(&$strPhpCode, 0, 1);
               $strNewPhpCode .= '<gbdGubed> ' . substr($strPhpCode, 0, $intPos1);
               $strPhpCode = substr($strPhpCode, $intPos1);
               
               if(!preg_match("/^\s*{/", $strPhpCode)) {
                  $strNewPhpCode .= ' { ';
                  $blockcount ++;  
               }
               
               $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
               break;
            
            case 'exit':
            case 'die':
               $intPos1 = gbdFindEOS(&$strPhpCode, 0, 1);
               $strNewPhpCode .= '<gbdGubed> { $GLOBALS[\'gbd\'][\'buffer\'] = ob_get_contents(); ob_end_clean(); ' . substr($strPhpCode, 0, $intPos1).  ' ;}<gbdEndGubed> ;';
               $strPhpCode = substr($strPhpCode, $intPos1);
               break;
               
            case 'else':
            case 'elseif':
               $intPos1 = gbdPregPos("/^[\s\r\f\n]*else(if)*?[\s\r\f\n]*/i", $strPhpCode, 0, true);
               $strNewPhpCode .= substr($strPhpCode, 0, $intPos1 );
               $strPhpCode = substr($strPhpCode, $intPos1);
               
               if(preg_match("/^[\s\n\f\r]*if/i", $strPhpCode)) {
               
                  $intPos1 = gbdFindEOS(&$strPhpCode, 0, 1);
                  $strNewPhpCode .= substr($strPhpCode, 0, $intPos1);
                  $strPhpCode = substr($strPhpCode, $intPos1);

                  if(!preg_match("/^\s*{/", $strPhpCode)) {
                     $strNewPhpCode .= ' { ';
                     $blockcount ++;  
                  }
               
               } elseif(!preg_match("/^[\s\n\f\r]*{/", $strPhpCode)) {
                  $strNewPhpCode .= '{ ';
                  $blockcount ++;  
               }
                    
               $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
               break;

            case 'case': 
            case 'default':
               if($blockcount > 0) {
                  $blockcount--;
                  $strNewPhpCode .= '}';
               }
               $intPos1 = gbdFindEOS(&$strPhpCode, 0, 2);
               $strNewPhpCode .= substr($strPhpCode, 0, $intPos1 );
               $strPhpCode = substr($strPhpCode, $intPos1);

               $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
               break;

            case 'function':
            case 'class':
               if($gbdRedefineFuncs) {
                  //$intPos1 = gbdFindEOS(&$strPhpCode, 0, 2);
                  $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
                  //echo substr($strPhpCode, 0, $intPos1 ) ."<br><br>";
                  $strTmp = ltrim(substr($strPhpCode, 0, $intPos1 ));
                  $strTmp = ltrim(substr($strTmp, strlen($token)));
                  $strTmp = 'gbdRepl_' . $strTmp;

                  $strNewPhpCode .= $token . ' ' . $strTmp;
                  $strPhpCode = substr($strPhpCode, $intPos1);

                  $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);

               }
               if($blockcount > 0) {
                  $blockcount--;
                  $strNewPhpCode .= '}';
               }
         //      break;
               
            case '{':
               $intPos1 = gbdPregPos("/ \s* \{+ [\s\n\r\f]* /x", $strPhpCode, 0, true);;//;gbdFindEOS($strPhpCode);
               $strNewPhpCode .= substr($strPhpCode, 0, $intPos1 );
               $strPhpCode = substr($strPhpCode, $intPos1);
               
               /*$intPos1 = gbdFindEOS(&$strPhpCode);
               $strNewPhpCode .= substr($strPhpCode, 0, $intPos1 );
               $strPhpCode = substr($strPhpCode, $intPos1);
                 */        
               $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
               break;
               
            case '}':
               $intPos1 = gbdPregPos("/ \s* {$token}+ [\s\n\r\f]* /x", $strPhpCode, 0, true);;//;gbdFindEOS($strPhpCode);
               $strNewPhpCode .= substr($strPhpCode, 0, $intPos1 );
               $strPhpCode = substr($strPhpCode, $intPos1);
               
               if($blockcount > 0) {
                  $blockcount--;
                  $strNewPhpCode .= '}';
               }
               
               $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
               break;
               
            case ';':
               $intPos1 = gbdPregPos("/ \s* \\{$token}+ [\s\n\r\f]* /x", $strPhpCode, 0, true);//;gbdFindEOS($strPhpCode);
               $strNewPhpCode .= ' <gbdEndGubed>;' . ($blockcount ? '}' : '' ) . str_replace(';', '', substr($strPhpCode, 0, $intPos1 ));
               $strPhpCode = substr($strPhpCode, $intPos1);
               
               if($blockcount > 0) {
                  $blockcount--;
               }
               
               $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
               break;
               
            case '?>':
               
               $strNewPhpCode .= ' ;<gbdGubed> {' . substr($strPhpCode, 0, $intPos1 );
               $strPhpCode = substr($strPhpCode, $intPos1);
               
               $intPos1 = gbdPregPos("/\<\?(php)?\s*/", $strPhpCode, 0, true);
               if($intPos1 < 0) {
               
                  $strNewPhpCode .= $strPhpCode . '<?php }';
                  $strPhpCode = '';
               
               } else {
                  $strNewPhpCode .= substr($strPhpCode, 0, $intPos1) . '}';
                  $strPhpCode = substr($strPhpCode, $intPos1);
                  $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
               }
               break;

                               
            default:
               $intPos1 = gbdFindEOS(&$strPhpCode);
               $strNewPhpCode .= '<gbdGubed> ' . substr($strPhpCode, 0, $intPos1 );
               $strPhpCode = substr($strPhpCode, $intPos1);
               
               $intPos1 = gbdPregPos($strPattern, $strPhpCode, 0, true);
               
         }
      }
     return $strNewPhpCode;
   }

   function gbdFindEOS(&$strPhpCode, $level = 0, $findone = 0) {
      $pos = 0;
      $len = 0;
      
      $strCode = $strPhpCode;
      while(1) {
         $token = ''; //[^<]\\?\[^>]
         $colontoo = ($findone == 2 ? '| : ' : '');
         if(preg_match("/ (\" | \s+case\s+? | \s+default\: | ' {$colontoo} | \( | \)  | \<\<\<  | ; | \/\* | \/\/ | \# | \{ | \} | \?\>) [\s\f\n\r]* /ix", $strCode, $arResult)) {
            $token = $arResult[0];
         }
         //echo " <br> :: {$token}<br>";
         
         switch(trim(strtolower($token))) {

            case 'default:':
            case 'case':
               $token = trim($token);
               $pos = strpos($strCode, $token, 0) + strlen($token) ;            
               $strCode = substr($strCode, $pos);
               $len += $pos;
               $pos = gbdFindEOS($strCode, $level + 1, 2);
               
               //echo ' -/' . substr($strCode, 0, $pos) . '/ ';
               $strCode = substr($strCode, $pos);
               $len += $pos - 1;
               
               return $len;
               break;
               
            case ':':
               $pos = strpos($strCode, $token, 0) +  strlen($token);
               $strCode = substr($strCode, $pos );
               $len += $pos ;
                  
               return $len;
               
               
            case '{':
               $pos = strpos($strCode, $token, 0) +  strlen($token);
               //echo ' -/' . substr($strCode, 0, $pos) . "/ 1(level $level $findone)";
               $strCode = substr($strCode, $pos);
               $len += $pos;
               
               $pos = gbdFindEOS($strCode, $level + 1);
               //echo ' /' . substr($strCode, 0, $pos) .  "/ 2(level $level $findone)";
               $strCode = substr($strCode, $pos);
               $len += $pos;
               
               //if($level == 0) 
               //   return $len; 
               break;
            
            case '(':
               $pos = strpos($strCode, $token, 0) +  strlen($token);
               //echo ' -/' . substr($strCode, 0, $pos) . "/ (level $level $findone)";
               $strCode = substr($strCode, $pos);
               $len += $pos;
               
               $pos = gbdFindEOS($strCode, $level + 1);
               //echo ' /' . substr($strCode, 0, $pos) .  "/ (level $level $findone)";
               $strCode = substr($strCode, $pos);
               $len += $pos;
               if($findone)
                  return $len;
               break;

            case '}':
            case ')':
               $pos = strpos($strCode, $token, 0) +  strlen($token);
               //echo ' -/' . substr($strCode, 0, $pos) .  "/ (leve$posl $level)";
               $strCode = substr($strCode, $pos);
               $len += $pos;
               
               if($findone || $level > 0)
                  return $len;
               break;

            case ';':
               $pos = gbdPregPos("/ ; /x", $strCode, 0 ,true);
               $strCode = substr($strCode, $pos );
               $len += $pos ;
               if($level == 0)
                  return $len- 1;
               break;
               
            case '"':
            case "'":
               $token = trim($token);
               $pos = strpos($strCode, $token, 0) + 1;
               //echo ' -/' . substr($strCode, 0, $pos) . '/ ';
               $strCode = substr($strCode, $pos);
               $len += $pos;
               
               //$strCode = substr($strCode, $pos);
               if(substr($strCode, 0, 1) == $token) {
                  $pos = gbdPregPos("/ {$token} [\s\n\r\f]* /x", $strCode, 0 ,true);
                  //echo ' /' . substr($strCode, 0, $pos) . '/ ';
                                    
               } else {
                  $pos = gbdPregPos("/ [^\\\\] {$token} [\s\n\r\f]* /x", str_replace('\\\\', '##', $strCode), 0 ,true);
                  //echo ' /' . substr(str_replace('\\\\', '##', $strCode), 0, $pos) . '/ ';
                  $strSection = substr($strPhpCode, $len, $pos);
                  $strSection = str_replace('__FILE__', '__F1LE__', $strSection);
                  $strPhpCode = substr($strPhpCode, 0, $len) . $strSection . substr($strPhpCode, $len + $pos);
                  
               }
               $strCode = substr($strCode, $pos);
               $len += $pos;
               break;

            case '/*':
               $pos = strpos($strCode, $token, 0) +  strlen($token);
               //echo ' -/' . substr($strCode, 0, $pos) . '/ ';
               $strCode = substr($strCode, $pos);
               $len += $pos;
               
               $pos = gbdPregPos("/ \*\/ [\s\f\n\r]* /x", $strCode);
               //echo ' /' . substr($strCode, 0, $pos) . '/ ';
               $strCode = substr($strCode, $pos);
               $len += $pos;
               break;
            
            case '#':   
            case '//':
               $pos = strpos($strCode, $token, 0) +  strlen($token);
               //echo ' -/' . substr($strCode, 0, $pos) . '/ ';
               $strCode = substr($strCode, $pos);
               $len += $pos;
               
               $pos = gbdPregPos("/ [\n\r\f][\n\r\f\s]* /x", $strCode);
               //echo ' /' . substr($strCode, 0, $pos) . '/ ';
               $strCode = substr($strCode, $pos);
               $len += $pos;
               break;
            
            case '<<<':
               $pos = strpos($strCode, $token, 0) +  strlen($token);
               //echo ' -/' . substr($strCode, 0, $pos) . '/ ';
               $strCode = substr($strCode, $pos);
               $len += $pos;
                           
               preg_match("/^(.*?)[\s\n\r\f]/", $strCode, $arResult);
               //print_r($arResult);
               $pos = gbdPregPos("/ [.\n\f\r]+? {$arResult[1]} [;\n\r\f]+?[\s\n\r\f]* /x", $strCode, 0 ,true);
               //echo ' /' . substr($strCode, 0, $pos) . '/ ';
               $strCode = substr($strCode, $pos);
               $len += $pos;
               if($level == 0)
                  return $len;
               break;
               
            case '?>':
               $pos = strpos($strCode, '?>', 0) ;
               //echo ' -/' . substr($strCode, 0, $pos) . "/ (level $level)";
               $strCode = substr($strCode, $pos);
               $len += $pos;
               
                if($level == 0)
                  return $len;  
               $pos = gbdPregPos("/ \<\? /x", $strCode, 0, true);
               //echo ' /' . substr($strCode, 0, $pos) . '/ ';
               $strCode = substr($strCode, $pos);
               $len += $pos;
               
               

               break;
                        
            case '':
               if(strlen($strCode) == 0)
                  return $len;
               echo "level $level " . strlen($strCode) . " <br>" .htmlentities($strCode);
               die();
                     
         }
         
      }      
   
   }
   
   function gbdPregPos($strNeedle, $strHaystack, $intOffset = 0, $addpattlen = 0) {

      if(preg_match($strNeedle, substr($strHaystack, $intOffset), $arResult)) {
      
         return strpos($strHaystack, $arResult[0], $intOffset) + ($addpattlen ? strlen($arResult[0]) : 0);
      } else
         return -1;
   }

   function gbdGetFirstToken($strToParse) {
      preg_match("/ \s* ( [\$a-zA-Z0-9_]+ | ; | \<\? | \?\> | { | } | \# | \/\/ | \= | \/\* | \*\/ )/x", $strToParse, $arResult);
      
      if(is_array($arResult) && isset($arResult[0]))
         return strtolower(Trim($arResult[0]));
      else
         return "";
   }
?>