<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>

   <head>
      <title>About the breakpoints test</title>
      <meta name="GENERATOR" content="Quanta Plus">
      <meta name="AUTHOR" content="Linus McCabe">
      <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
      <link rel="stylesheet" type="text/css" href="../../../default.css" />
   </head>
   <body>
   
      <h1>
         Breakpoints
      </h1>
      <h2>
         About
      </h2>
      <p>
         This script is good for testing breakpoints. There are three types of breakpoints in Gubed:
      </p>
      <ul>
         <li>Line breakpoints</li>
         <li>Hardcoded line breakpoints</li>
         <li>Conditional breakpoints</li>
      </ul>
      <h3>Line Breakpoints</h3>
      <p>
         Line breakpoints are added and removed in the debugging client. When the script is executed, execution will
         be halted when the line of the breakpoint is reached.
      </p>
      <h3>Hardcoded Breakpoints</h3>
      <p>
         Hardcoded breakpoints are breakpoints written in the PHP source code. When a debugged script is executed
         and it reaches a line with a hardcoded breakpoint, execution is halted and there is no way to prevent the halt.
         This can be useful for places the code really shouldn't reach, but it might because of logic errors. For example:
      </p>
      <pre>
            if($row == 0)
               echo "This is a valid possibility";
            else if($row &lt; 10)
               echo "So is this";
            else {
               echo "But this should never happen unless something is wrong";
               /* STOP */
            }
      </pre>
      <p>
         The /* STOP */ will make a script debugged with Gubed halt. When the script is not debugged, nothing will 
         happen since it's then just a PHP comment.
      </p>
      <h3>Conditional Breakpoints</h3>
      <p>
         Conditional breakpoints are breakpoints that halts the script when certain criterias are fulfilled, for example a 
         variable gets a certain value or the return value of an expression changes.
      </p>
      <p>
         Conditional breakpoints can be told only to halt execution if it's currently in a certain file, class or function.
      </p>
      <h2>
         Things to test
      </h2>
      <p>
         When running the test, you can try the different kinds of breakpoints by 
      </p>
      <ul>
         <li>
            adding line breakpoints in your client
         </li>
         <li>
            clicking the 'hit hardcoded breakpoint' link, which will reload the script with a GET variable that will make
            it hit a hardcoded breakpoint.
         </li>
         <li>
            add a condition to halt for example when '$boolVar changes value'.
         </li>
      </ul>
      <h2>
         Run the test
      </h2>
      <ul>
         <li>
            <a href="test.php">Run without debugged activated</a>
         </li>
         <li>
            <a href="../../../StartSession.php?gbdScript=<?php echo dirname($_SERVER['SCRIPT_NAME']) . "/test.php"; ?>">Run with debugger activated</a>
         </li>
      </ul>
      <h2>
         Source code
      </h2>
      <h3>
         test.php
      </h3>
      <?php
         highlight_file('test.php');
      ?>
</html>
