<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<?php

   $memlimit = 0;
   if(function_exists('memory_get_usage')) {
      $memlimit = ini_get('memory_limit');
      $memlimit = trim($memlimit);
      $last = $memlimit{strlen($memlimit)-1};
      switch($last) {
         case 'k':
         case 'K':
               $memlimit *= 1024;
               break;
         case 'm':
         case 'M':
               $memlimit *= 1048576;
               break;
      }
   }
?>
<html>
   <head>
      <title>
         RegExpTest
      </title>
      <style type="text/css">
         a.parseok {
            font-weight: normal;
            color: green;
            text-decoration: none;
         }
         a.parsefailed {
            font-weight: bold;
            color: red;
            text-decoration: none;
         }
      </style>
      <link rel="stylesheet" type="text/css" href="../default.css" />
   </head>

<body>

<h1>
   Gubed PHP Debugger
</h1>
<h2>
   Developer aid
</h2>
      
<?php
set_time_limit(3600);
require("../GubedFunctions.php");
            
if(!isset($_REQUEST['file'])) {
?>
   
   <p>
      These pages are meant to aid the Gubed developers to find parser errors and test the system. If you press
      'Start scanning' below, your system will be scanned for php files. The files will be read and parsed by 
      Gubed to test the Gubed parser.
   </p>
   <p>
      <strong>
         No files will be altered on disc!
      </strong>               
   </p>
   <p>
      Performing the scan yourself and reporting problems to the developers is an easy
      way to help the gubed development!
   </p>
   <p>
      Note that if you have a lot of php-files on your system, the test might take some time and the php max time limit will be increased before starting. About 2000 files will be tested at a time<?php
         if($memlimit > 0)
            echo ", unless php max allocatable memory is reached (Currently at {$memlimit} bytes)";
      ?>.
   </p>
   <p>
      If you get a 'cannot redclare class/function X' error, Gubed has tried to scan a file that contains a class or function that is already defined. If this happens, just click on the number to the left before the error to restart scanning from the next file, so that the file with the first definition isn't included in the scan.
   </p>
   <p>
      <a href="?file=0&searchsystem=1">Start scanning entire system (*nix/Linux only)</a> or specify a path
      
      <FORM ACTION="?" METHOD=GET> specify a path <INPUT TYPE=TEXT NAME="testfilespath" SIZE=40>
         <INPUT TYPE=HIDDEN NAME="file" VALUE=0>
         <BR> <INPUT TYPE=SUBMIT Value="Search">
      </FORM>
 </p>
               
               
<?php
} else if (is_numeric($_REQUEST['file'])) {
?>
   
   <p>
      Scanning system for php files and testing the parser on them (assuming backtick operator works and 'locate' is available).
   </p>
   <p>   
      Files that doesn't parse as they are wont be tested, other files will report wether they
      parse ok after Gubed processing or not. You can press the parse status on any file to get a more detailed
      scan of the file.
   </p>
   <p>
      If you have files that doesn't parse, please help by sending the file or the code snippet to the Gubed
      developers!
   </p>
   <pre><?php

   
      /* get the testfiles array if a directory is specified by user */
      
   if (isset($_REQUEST['testfilespath'])){
      $testfilespath = $_REQUEST['testfilespath'];            
      $i = 0;
      $i2 = 0;

         /* handle missing trailing / */
         
      if (eregi("/$",$testfilespath)){
         $Open = opendir ("$testfilespath");
      }else{
         $testfilespath = $testfilespath . "/";
         $Open = opendir ("$testfilespath");
      }
      
      while ($possibleFile = readdir ($Open)) {
         if ( eregi ("\.php$", $possibleFile) OR eregi ("\.php3$",   $possibleFile) OR eregi ("\.phtml$", $possibleFile)){
            $testfiles[$i] = $testfilespath . $possibleFile;
            $i++;
            
            /* put subdirectories into an array so user can dive into them after
               parent directory is parsed */
               
         }elseif (is_dir ($testfilespath.$possibleFile)) {
            if ($possibleFile != ".."  && $possibleFile != "."){                
               $subDirectories[$i2] = $testfilespath . $possibleFile . "/" ;
               $i2++;
            }
         }
      }
   closedir($Open);
   
         /* get the testfiles array if the user specified search system */
         
   }elseif (isset($_REQUEST['searchsystem'])){
   $testfiles = `locate \*.php`;
   $testfiles = split("\n", $testfiles);
   }

   $redef = 0;
   $max = $_REQUEST['file'] + 200;

      // Main for loop to evaluate each php file.

   for($count = $_REQUEST['file']; $count < $max && isset($testfiles[$count]); $count++) {
   
            // Make sure we dont use too much memory

      if(function_exists('memory_get_usage')) {
         $testmemory_get_usage = memory_get_usage();
         if($memlimit > 0 && $testmemory_get_usage > ($memlimit * 0.9)){
            print ("\n <br> Oh dear, you appear to be running out of memory: You have used $testmemory_get_usage out of $memlimit <br>\n");
            break;
         }
      }

         // Get an individual file and it's contents for the $testfiles array.
         
      $testfile = $testfiles[$count];
      $filecontents = @file_get_contents($testfile);

         // provide a link with the file count.

      $count_number = $count + 1;
      $lines = substr_count($filecontents, "\n");
               
      if (isset($testfilespath)){
         print ("<a href=\"?file=$count&testfilespath=$testfilespath\">$count_number</a>: $testfile $lines lines ");
      }else{
         print ("<a href=\"regexptest.php?file=$count&searchsystem=1\">$count_number</a>: $testfile $lines lines ");   
      }   

      if($filecontents) {
         
         ob_start();         
            // check that the unmodified file evaluates as php code.
         $parsedok = eval(' return 1; ?>'. $filecontents);
         ob_end_clean();
         
         if($parsedok) {
            $redef++;
               // check that the modified code evaluates as php code.
            $gbdParsedPhpCode = gbdParseCode('/this/file.php', $filecontents, 1, &$debug, 'gbdRedef' . $redef);
            ob_start();
            $parsedok = eval(' return 1; ?>'. $gbdParsedPhpCode);
            ob_end_clean();

               // if modified code evalutes ok display parsed OK.

            if(isset($testfilespath)){
               if($parsedok)
                  echo '<a href="diffdisplay.php?file=' . $testfile . '&count=' . $count . '&testfilespath=' . $testfilespath .'" class="parseok">Parsed ok!'; 
               else
                  echo '<a href="diffdisplay.php?file=' . $testfile . '&count=' . $count . '&testfilespath=' . $testfilespath .'" class="parsefailed">   ***   Did not parse ok!   ***';
               echo "</a>\n";
            }else{
               if($parsedok)
                  echo '<a href="diffdisplay.php?file=' . $testfile . '&count=' . $count .'" class="parseok">Parsed ok!'; 
               else
                  echo '<a href="diffdisplay.php?file=' . $testfile . '&count=' . $count . '" class="parsefailed">   ***   Did not parse ok!   ***';
               echo "</a>\n";
            }


         } else {
            echo "Original file did not parse\n";     // if original file does not evaluate.
            $max ++;
         }
      } else
         echo "Empty/Unreadable file\n";
      }

      print ("<p>");
      if ($count >= $max && isset($_REQUEST['searchsystem'])){               
         print ("<a href=\"?file=$count&searchsystem=1\">Next</a><br>\n");
      }elseif ($count >= $max){
         print ("<a href=\"?file=$count\">Next</a><br>\n");                
      }
   
      if (isset ($subDirectories)){
         for ($i2=0; $i2 < count($subDirectories); $i2++){
         print ("<a href=\"regexptest.php?file=0&testfilespath=$subDirectories[$i2]\">$subDirectories[$i2]</a><br>\n");
      }
   }
   ?>
      </p>
   <?php
}
   ?>
</body>
</html>